/* -*- mode: c++; c-basic-offset: 4; -*- */
#include "buffer_pool.hh"
#include "buffer.hh"
#include <stdexcept>

using namespace sends;
using namespace std;

//======================================  Constructor
buffer_pool::buffer_pool(long nbuf, long lbuf) 
    : mBufSize(lbuf), mQueue(nbuf)
{
    for (long i=0; i<nbuf; i++) {
	buffer* buf = new buffer(lbuf);
	buf->set_pool(this);
	return_buffer(buf);
    }
}

//======================================  Destructor
buffer_pool::~buffer_pool(void) {
    buffer* buf = 0;
    while (mQueue.pop_if_present(buf)) {
        delete buf;
    }
}

//======================================  Get a buffer
buffer* 
buffer_pool::get_buffer(void) {
    buffer* buf = 0;
    mQueue.pop(buf);
    return buf;
}

//======================================  Get a buffer
buffer* 
buffer_pool::get_buffer_now(void) {
    buffer* buf = 0;
    bool ok = mQueue.pop_if_present(buf);
    if (!ok) buf = 0;
    return buf;
}

//======================================  Return a buffer.
void 
buffer_pool::return_buffer(buffer* buf) {
    mQueue.push(buf);
}
